<?php

# This is an error handler. If a Java applet bails out it can
# call this script and display an error message in the browser.

$title = "Test your broadband link: ISP BitTorrent traffic manipulation";
$store_directory = "logs";

# $_GET['id'] is the ID of the client
# $_GET['msg'] is a message string that describes the problem (spaces are encoded as %20)
# $_GET['mid'] optional, contains a maschine readable message class ID
# $_GET['exception'] optional, contains the exception message from java (spaces are encoded as %20)
# $_GET['sysinfo'] optional, contains sysinfos from the client (spaces are encoded as %20)

if($_GET['id'] && $_GET['msg']){

  # Stats about user-satisfaction
  if(1){
    $id = getenv('REMOTE_ADDR');
    $name = gethostbyaddr($id);
    $fp = fopen("$store_directory/bt.stats", "a");
    fwrite($fp, time().";$id;$name;error;".$_GET['id'].";".$_GET['msg'].";".@$_GET['exception'].";".@$_GET['sysinfo']."\n");
    fclose($fp);
  }

  echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<html>
  <head>
    <title>$title</title>
    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-15\">
    <link rel=\"stylesheet\" href=\"mpi.css\" type=\"text/css\">
  </head>

  <body>
    <a href=\"http://www.mpi-sws.mpg.de\"><img src=\"pics/mpisws-logo.png\" alt=\"MPI-SWS\" style=\"border:0px;background-color:white;vertical-align:bottom;\"></a>
    <h1 style=\"font-family:serif;\">$title</h1>

<div style=\"border:1px solid #69acff;padding:15px;\">

    <h3>We are sorry, the test failed due to a problem.</h3>
";


  # We support a maschine readable msg ID to tell us how to react.
  # 10: Timeout. Connection failed
  # 11: Connection broke

 if(isset($_GET['mid'])){
    if($_GET['mid'] == 10){
      echo "<p>The connection to the measurement server timed out. This can happen if it takes too long to load the applet.
            <a href=\"http://broadband.mpi-sws.org/transparency/bttest.php\">Please try again by clicking here</a>.</p>";
    }
    elseif($_GET['mid'] == 11){
      echo "<p>The connection to the measurement server was lost.
            <a href=\"http://broadband.mpi-sws.org/transparency/bttest.php\">Please try again by clicking here</a>.</p>";
    }
    elseif($_GET['mid'] == 12){
      echo "<p>There was an internal error.
            <a href=\"http://broadband.mpi-sws.org/transparency/bttest.php\">Please try again by clicking here</a>.</p>";
    }
    elseif($_GET['mid'] == 14){
      echo "<p>Your measurement results cannot be retrieved.
            <a href=\"http://broadband.mpi-sws.org/transparency/bttest.php\">Please try again by clicking here</a>.</p>";
    }
    else{
# Unknown code
#      echo "<p></p>";
    }
  }
  else{
    # email to us.
    $from = "broadband@mpi-sws.mpg.de";
    $msg = $_GET['msg'];
    $id = $_GET['id'];

    $server = $_SERVER['SERVER_NAME'];
    $server_ip = $_SERVER['SERVER_ADDR'];

    $out = "";
    if(isset($_GET['exception'])){
      $out .= "Exception: ".$_GET['exception'] . "\n";
    }
    if(isset($_GET['sysinfo'])){
      $out .= "Sysinfo: ".$_GET['sysinfo']."\n";
    }
    if(file_exists("latest.bt")){
      $out .= "latest.bt:\n-------------\n\n";
      $handle = fopen("latest.bt", "r");
      while($tmp = fgets($handle)){
	$out .= $tmp;
      }
    }
    else{
      $out = "No latest.bt present\n\n";
    }

    $message = "The online tool failed for $id on $server ($server_ip)!\n\n$msg\n\n$out\n";
    # Send mail
    $ret = mail("mdischin@mpi-sws.mpg.de", "BitTorrent Online Tool error", $message, "From: $from", "-f$from");

    echo "<p>An error report was automatically sent to us. If you have any additional information that might help us
           debugging this problem, please email us. Thank you.</p>";
  }

  echo "<p>&nbsp;</p> <p>For details on our research on broadband networks please refer to our
       <a href=\"http://broadband.mpi-sws.org/transparency/\">network transparency project webpage</a></p>

    <p>In case you have questions about this tool or our research, please contact us: 
<img src=\"http://broadband.mpi-sws.org/pics/email.png\" alt=\"broadband @at@ mpi-sws mpg de\" style=\"margin-left:5px;margin-bottom:-6px;\"></p>
         </div>
        </body>
       </html>";

}
else{
  header("Location: http://broadband.mpi-sws.org/transparency/");
  exit;
}

?>
