<?php

# A simple script that generates a directory listing.
# Helpful if the installed webserver is configured to not list the
# content of directories.

if(isset($_GET['html'])){

 echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<html>
  <head>
    <title>Directory listing</title>
    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">
  </head>

  <body>
  <h1>Directory listing</h1>
";

}

$handle = opendir(".");
while($entry = readdir($handle)){

  if(($entry == ".") || ($entry == "..") || ($entry == ".htaccess") || ($entry == ".htpasswd")){
    continue;
  }

  if(isset($_GET['html'])){
    print "<a href=\"$entry\">$entry</a><br>\n";
  }
  else{
    print "$entry\n";
  }
}

if(isset($_GET['html'])){
  echo "</body></html>";
}

?>
